## fife 0.3.3+r2+dfsg1

=== SConstruct ===
# -*- coding: utf-8 -*-

# ####################################################################
#  Copyright (C) 2005-2009 by the FIFE team
#  http://www.fifengine.de
#  This file is part of FIFE.
#
#  FIFE is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
# ####################################################################

import os, sys
import utils.scons.scons_utils as utils
from distutils.sysconfig import get_python_lib

_sep = os.path.sep

#**************************************************************************
#add any command line options here
#**************************************************************************

vars = Variables()
vars.Add(PathVariable('DESTDIR', 
			'Destination directory (prepended to prefix)',
			None,
			PathVariable.PathAccept ))

#propagate the invoking users complete external environment
env = Environment(variables = vars, 
			ENV = os.environ,
			DESTDIR = '${DESTDIR}')

env.EnsureSConsVersion(1,2)

AddOption('--enable-debug',
		dest='enable-debug',
		action="store_true",
		help='Builds the debug version of the binaries',
		default=False)
		
AddOption('--disable-opengl',
		dest='disable-opengl',
		action="store_true",
		help='Disable OpenGL support',
		default=False)		

AddOption('--disable-zip',
		dest='disable-zip',
		action="store_true",
		help='Disable ZIP archive support',
		default=False)	

AddOption('--disable-log',
		dest='disable-log',
		action="store_true",
		help='Disable engine logging support',
		default=False)	

AddOption('--enable-rend-camzone',
		dest='enable-rend-camzone',
		action="store_true",
		help='Enables camera zone renderer',
		default=False)
		
AddOption('--enable-rend-grid',
		dest='enable-rend-grid',
		action="store_true",
		help='Enables camera grid renderer',
		default=False)

AddOption('--enable-profile',
		dest='enable-profile',
		action="store_true",
		help='Build with profiling information.  This automatically enables debug.',
		default=False)
		
AddOption('--prefix',
		dest='prefix',
		nargs=1, type='string',
		action='store',
		metavar='DIR',
		help='installation prefix')
		
AddOption('--python-prefix',
		dest='python-prefix',
		nargs=1, type='string',
		action='store',
		metavar='DIR',
		help='Python module installation prefix')
		
AddOption('--local-tinyxml',
		dest='local-tinyxml',
		action="store_true",
		help='Forces fife to use the local version of tinyxml that ships with fife',
		default=False)

AddOption('--lib-dir',
		dest='lib-dir',
		nargs=1, type='string',
		action='store',
		metavar='DIR',
		help='Shared Library install location') 
		
#**************************************************************************
#save command line options here
#**************************************************************************
if GetOption('enable-debug'):
	debug = 1
	env['FIFE_DEBUG'] = True
else:
	debug = 0
	env['FIFE_DEBUG'] = False
	
if GetOption('disable-opengl'):
	opengl = 0
else:
	opengl = 1

if GetOption('disable-zip'):
	zip = 0
else:
	zip = 1

if GetOption('disable-log'):
	log = 0
else:
	log = 1

if GetOption('enable-rend-camzone'):
	rend_camzone = 1
else:
	rend_camzone = 0

if GetOption('enable-rend-grid'):
	rend_grid = 1
else:
	rend_grid = 0

if GetOption('enable-profile'):
	debug = 1
	profile = 1
else:
	profile = 0
	
if GetOption('local-tinyxml'):
	local_tinyxml = 1
	env['LOCAL_TINYXML'] = True
else:
	local_tinyxml = 0
	env['LOCAL_TINYXML'] = False

#**************************************************************************
#set the installation directories.
#**************************************************************************
prefix = GetOption('prefix')
if prefix is None:
	if sys.platform == 'win32':
		prefix = '\\fife'
	elif sys.platform == 'darwin':
		prefix = '/opt/local'
	else:
		prefix = '/usr/local'

pythonprefix = GetOption('python-prefix')
if pythonprefix is None:
	pythonprefix = get_python_lib()

if env.has_key('DESTDIR'):
	prefix = env['DESTDIR'] + prefix
	pythonprefix = env['DESTDIR'] + pythonprefix

libdir = GetOption('lib-dir')
if libdir is None:
	libdir = os.path.join(prefix, 'lib')
else:
	libdir = os.path.join(prefix, libdir)
	
env['LIBDIR'] = libdir

#**************************************************************************
#get platform specific information
#**************************************************************************
platformConfig = utils.getPlatformConfig()
env = platformConfig.initEnvironment(env)
env = platformConfig.addExtras(env, opengl)

#**************************************************************************
#define custom library/header check functions
#**************************************************************************
conf = Configure(env,
		custom_tests = {'checkPKG': utils.checkPKG,
				'checkConf': utils.checkConf },
				conf_dir = os.path.join('#','build','.sconf_temp'),
				log_file = os.path.join('#','build','config.log'),
				clean=True)
	
def checkForLib(lib, header='', language='c++'):
	ret = conf.checkPKG(lib)
	if not ret:
		ret = conf.checkConf(lib)
		if not ret:
			if len(header):
				ret = conf.CheckLibWithHeader(libs=lib, header=header, language=language)
			else:
				ret = conf.CheckLib(library=lib, language=language)
					
	return ret
	
def checkForLibs(env, liblist, required=1, language='c++'):
	ret = 0
	for lib, header in liblist:
		# special case for the user overriding on the scons build line to
		# force using the local tinyxml version that ships with fife
		#if not isinstance(lib, tuple) and lib == 'tinyxml' and env['LOCAL_TINYXML'] == True:
			#env.Append(CPPDEFINES = ['USE_LOCAL_TINY_XML'])
			#continue
			
		if (isinstance(lib, tuple)):
			for item in lib:
				ret = checkForLib(item, header, language)
					
				if ret:
					env.AppendUnique(LIBS = [item])
					break
		else:
			# special handling for tinyxml
			if lib == 'tinyxml':
				if env['LOCAL_TINYXML'] == False:
					# look for system version of tinyxml
					ret = checkForLib(lib, header, language)
					
					if ret:
						# system version found so set the compilation flag
						# and store the lib in the lib list
						env.AppendUnique(CPPDEFINES = ['USE_SYSTEM_TINY_XML'])
						env.AppendUnique(LIBS = [lib])
			else:	
				ret = checkForLib(lib, header, language)
				if ret:
					env.AppendUnique(LIBS = [lib])
	
		if required and not ret:
			if (isinstance(lib, tuple)):
				for item in lib:
					print 'Required lib %s not found!' %item
			else:
				print 'Required lib %s not found!' %lib
			Exit(1)
		#elif not required and not ret:
			# special handling for libs that are not required
			# and were not added
			#if not isinstance(lib, tuple) and lib == 'tinyxml':
				# we will use our own included version if
				# the system version was not found
				#env.Append(CPPDEFINES = ['USE_LOCAL_TINY_XML'])
				
	return env
				
		
#**************************************************************************
#check the existence of required libraries and headers
#**************************************************************************
required_libs = platformConfig.getRequiredLibs(opengl)
optional_libs = platformConfig.getOptionalLibs(opengl)

required_headers = platformConfig.getRequiredHeaders(opengl)

# do not run the check for dependencies if you are running
# a clean or building the external dependencies
if not GetOption('clean') and 'ext' not in COMMAND_LINE_TARGETS:
	if required_libs:
		env = checkForLibs(env, required_libs, required = 1)
	if optional_libs:
		env = checkForLibs(env, optional_libs, required = 0)
	if required_headers:
		for h in required_headers:
			conf.CheckHeader(h)

#**************************************************************************
#set variables based on command line and environment options
#**************************************************************************

if os.environ.has_key('SWIG'):
	env['SWIG'] = os.environ['SWIG']

haveusercxxflags = False

if os.environ.has_key('CXXFLAGS'):
	usercxxflags = Split(os.environ['CXXFLAGS'])
	haveusercxxflags = True
elif ARGUMENTS.get('CXXFLAGS'):
	usercxxflags = Split(ARGUMENTS.get('CXXFLAGS'))
	haveusercxxflags = True

if debug:
	if haveusercxxflags:
		env.AppendUnique(CXXFLAGS=usercxxflags)
	else:	
		env.AppendUnique(CXXFLAGS=['-O0', '-Wall', '-Wno-unused'])
		
	env.AppendUnique(CXXFLAGS=['-g', '-D_DEBUG'])
	env.AppendUnique(LINKFLAGS=['-Wl'])
	engine_var_dir = os.path.join('build','engine','debug')
	tests_var_dir = os.path.join('build','tests','debug')
	print "Building DEBUG binaries..."
else:
	if haveusercxxflags:
		env.AppendUnique(CXXFLAGS=usercxxflags)
	else:	
		env.AppendUnique(CXXFLAGS=['-O2', '-Wall', '-Wno-unused'])
	
	env.AppendUnique(LINKFLAGS=['-Wl'])
	engine_var_dir = os.path.join('build','engine','release')
	tests_var_dir = os.path.join('build','tests','release')
	print "Building RELEASE binaries..."

if opengl: 
	env.Append(CPPDEFINES = ['HAVE_OPENGL'])
if zip:
	env.Append(CPPDEFINES = ['HAVE_ZIP'])
if log:
	env.Append(CPPDEFINES = ['LOG_ENABLED'])
if rend_camzone:
	env.Append(CPPDEFINES = ['RENDER_CAMZONES'])
if rend_grid:
	env.Append(CPPDEFINES = ['RENDER_GRID'])
if profile:
	env.Append(CXXFLAGS = ['-pg'])
	env.Append(LINKFLAGS = ['-pg'])
	
#**************************************************************************
#global compiler flags used for ALL targets
#**************************************************************************
env.Append(CPPPATH='#engine/core')

#**************************************************************************
#variables to pass to the SConscript
#TODO: clean this up a bit.  Should probably make sure unittest++ exists.
#**************************************************************************
opts = {'SRC' : os.path.join(os.getcwd(), 'engine',),
		'DLLPATH' : os.path.join(os.getcwd(), 'build', 'win32', 'binaries', 'mingw'),
		'DEBUG' : debug,
		'PREFIX' : prefix,
		'LIBDIR' : libdir,
		'TESTLIBS' : ['fife', 'UnitTest++'],
		'PYTHON_PREFIX' : pythonprefix,
		'WRAP_COPY_DEST' : os.path.join('#engine', 'swigwrappers', 'python'),
		'PYLIB_COPY_DEST' : os.path.join('#engine', 'python', 'fife')}

opts['FIFE_VERSION'] = utils.get_fife_version(os.path.join(opts['SRC'], 'core'));

if debug:
	opts['LIBPATH'] = os.path.join(os.getcwd(), 'build', 'engine', 'debug')
else:
	opts['LIBPATH'] = os.path.join(os.getcwd(), 'build', 'engine', 'release')

#**************************************************************************
#target for static and shared libraries
#**************************************************************************
Export('env')

#build the engine
env.SConscript('engine/SConscript', variant_dir=engine_var_dir, duplicate=0, exports='opts')

#build the engine tests
env.SConscript('tests/core_tests/SConscript', variant_dir=tests_var_dir, duplicate=0, exports='opts')

#build the external dependencies
env.SConscript('ext/SConscript')

#**************************************************************************
#documentation target
#**************************************************************************
def generate_docs(target = None, source = None, env = None):
	os.system('doxygen $SOURCES')

doc_builder = Builder(action = generate_docs)
env.Append(BUILDERS = {'BuildDocs': doc_builder})
Alias('docs', env.BuildDocs('docs', os.path.join('doc', 'doxygen', 'doxyfile')))

#**************************************************************************

=== debian/changelog ===
fife (0.3.3+r2+dfsg1-4) unstable; urgency=low

  * Import patch from upstream to add support for smaller widescreen
    displays and fixes crashes on such systems (Closes: #655861)
  * Set Maintainer to Debian Games Team, me to uploader
  * Add VCS git URLs

 -- Christoph Egger <christoph@debian.org>  Sat, 14 Jan 2012 13:50:13 +0100

fife (0.3.3+r2+dfsg1-3) unstable; urgency=low

  * Add hurd as well

 -- Christoph Egger <christoph@debian.org>  Mon, 26 Dec 2011 09:36:05 +0100

fife (0.3.3+r2+dfsg1-2) unstable; urgency=low

  * Add kFreeBSD support (pretend being linux2)

 -- Christoph Egger <christoph@debian.org>  Fri, 23 Dec 2011 20:15:29 +0000

fife (0.3.3+r2+dfsg1-1) unstable; urgency=low

  * New upstream release
  * First release in proper Debian (Closes: #632360)

 -- Christoph Egger <christoph@debian.org>  Tue, 15 Nov 2011 16:00:36 +0100

fife (0.3.2+svn3687-1) weekly; urgency=low

  * New SVN Snapshot

 -- Christoph Egger <christoph@debian.org>  Thu, 23 Jun 2011 15:11:25 +0200

fife (0.3.2+svn3593-2) unstable; urgency=low

  * fix building with python2.7 around

 -- Christoph Egger <christoph@unknown-horizons.org>  Sat, 16 Apr 2011 19:53:11 +0200

fife (0.3.2+svn3593-1) unstable; urgency=low

  * new snapshot

 -- Christoph Egger <christoph@unknown-horizons.org>  Mon, 04 Apr 2011 17:13:48 +0200

fife (0.3.2+svn3587) unstable; urgency=low

  * new snapshot

 -- Christoph Egger <christoph@unknown-horizons.org>  Sun, 13 Feb 2011 16:19:17 +0100

fife (0.3.1+svn3431-1) unstable; urgency=low

  * Initial release.

 -- Christoph Egger <christoph@unknown-horizons.org>  Thu, 16 Sep 2010 18:23:07 +0200

=== debian/control ===
Source: fife
Uploaders: Christoph Egger <christoph@debian.org>
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Section: libdevel
Priority: optional
Build-Depends: debhelper (>= 7.0.50~),
 scons,
 libsdl1.2-dev,
 libboost-dev,
 libsdl-ttf2.0-dev,
 libsdl-image1.2-dev,
 libvorbis-dev,
 libalut-dev,
 python-all-dev (>= 2.6.6-3~),
 libboost-regex-dev,
 libboost-filesystem-dev,
 libboost-test-dev,
 swig,
 chrpath,
 zlib1g-dev,
 libxcursor-dev,
 libopenal-dev,
 libasound2-dev,
 libguichan-dev,
 libtinyxml-dev
X-Python-Version: >= 2.6
Vcs-Git: git://git.debian.org/git/pkg-games/fife.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/fife.git
Standards-Version: 3.9.2
Homepage: http://fifengine.de

Package: python-fife
Section: python
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Breaks: ${python:Breaks}
Description: FIFE is a multi-platform isometric game engine
 FIFE stands for Flexible Isometric Free Engine and is a cross
 platform game creation framework written in C++. It provides you with
 the ability to create a game using Python interfaces. FIFE also comes
 as a DLL or static library so you can use C++ as well.

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += -j$(NUMJOBS)
endif

export PYVERS=$(shell pyversions -vr)

%:
		dh $@ --with python2

override_dh_auto_configure:	$(PYVERS:%=debian/stamps/configure-python%)
debian/stamps/configure-python%:
	mkdir build-python$*
	cp -r build engine ext utils SConstruct setup.py test_fife.py build-python$*
	find build-python$*/engine/core/ext/tinyxml -type f -a \! -name fife_tinyxml.h -delete
	touch $@

override_dh_auto_build:	$(PYVERS:%=debian/stamps/build-python%)
debian/stamps/build-python%:
	python$* $(shell which scons) -C build-python$* fife-python $(SCONSOPTS)

override_dh_auto_install:	$(PYVERS:%=debian/stamps/install-python%)
debian/stamps/install-python%:
	python$* $(shell which scons) -C build-python$* DESTDIR=$(CURDIR)/debian/python-fife install-python $(SCONSOPTS)
	find $(CURDIR)/debian/python-fife -name '*.so' -exec chrpath -d {} \;

override_dh_auto_clean:
	rm -fr build-python*
	rm -f debian/stamps/*
	dh_clean

# override_dh_builddeb:
# 	dh_builddeb -- -Zxz

## fife 0.3.3+r3

=== SConstruct ===
--- 
+++ 
@@ -86,6 +86,12 @@
 		help='Build with profiling information.  This automatically enables debug.',
 		default=False)
 		
+AddOption('--enable-release-assert',
+		dest='enable-release-assert',
+		action="store_true",
+		help='Build with assert enabled in release mode.  This should only be used when you have a tricky bug to track down.',
+		default=False)
+	
 AddOption('--prefix',
 		dest='prefix',
 		nargs=1, type='string',
@@ -113,6 +119,8 @@
 		metavar='DIR',
 		help='Shared Library install location') 
 		
+
+		
 #**************************************************************************
 #save command line options here
 #**************************************************************************
@@ -153,6 +161,11 @@
 	profile = 1
 else:
 	profile = 0
+	
+if GetOption('enable-release-assert'):
+	assert_release = 1
+else:
+	assert_release = 0
 	
 if GetOption('local-tinyxml'):
 	local_tinyxml = 1
@@ -311,7 +324,6 @@
 		env.AppendUnique(CXXFLAGS=['-O0', '-Wall', '-Wno-unused'])
 		
 	env.AppendUnique(CXXFLAGS=['-g', '-D_DEBUG'])
-	env.AppendUnique(LINKFLAGS=['-Wl'])
 	engine_var_dir = os.path.join('build','engine','debug')
 	tests_var_dir = os.path.join('build','tests','debug')
 	print "Building DEBUG binaries..."
@@ -321,7 +333,9 @@
 	else:	
 		env.AppendUnique(CXXFLAGS=['-O2', '-Wall', '-Wno-unused'])
 	
-	env.AppendUnique(LINKFLAGS=['-Wl'])
+	if not assert_release:
+		env.AppendUnique(CPPDEFINES = ['NDEBUG'])
+	
 	engine_var_dir = os.path.join('build','engine','release')
 	tests_var_dir = os.path.join('build','tests','release')
 	print "Building RELEASE binaries..."
@@ -360,6 +374,7 @@
 		'PYLIB_COPY_DEST' : os.path.join('#engine', 'python', 'fife')}
 
 opts['FIFE_VERSION'] = utils.get_fife_version(os.path.join(opts['SRC'], 'core'));
+opts['FIFE_REVISION'] = utils.get_fife_revision()
 
 if debug:
 	opts['LIBPATH'] = os.path.join(os.getcwd(), 'build', 'engine', 'debug')
@@ -382,12 +397,3 @@
 
 #**************************************************************************
 #documentation target
-#**************************************************************************
-def generate_docs(target = None, source = None, env = None):
-	os.system('doxygen $SOURCES')
-
-doc_builder = Builder(action = generate_docs)
-env.Append(BUILDERS = {'BuildDocs': doc_builder})
-Alias('docs', env.BuildDocs('docs', os.path.join('doc', 'doxygen', 'doxyfile')))
-
-#**************************************************************************

=== debian/changelog ===
fife (0.3.3+r3-3) unstable; urgency=low

  * Include NMU by Anton Gladky, thanks!

 -- Christoph Egger <christoph@debian.org>  Sun, 30 Dec 2012 12:53:30 -0800

fife (0.3.3+r3-2) unstable; urgency=low

  * Import upstream (SVN 3949) patch to fix memory leaking (Closes:
    #696676)

 -- Christoph Egger <christoph@debian.org>  Sat, 29 Dec 2012 16:36:26 -0800

fife (0.3.3+r3-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add engine/core/util/utf8/utf8* to copyright file (Closes: #690370)
  * Use packaged version of Glee-library to fix lintian embedded-library
    autoreject tag.

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 24 Oct 2012 21:15:06 +0200

fife (0.3.3+r3-1) unstable; urgency=low

  * New upstream release
  * Build-depend on libpng-dev
  * Enable testsuite instead of striping it from the tarball as it is
    free now

 -- Christoph Egger <christoph@debian.org>  Sun, 22 Apr 2012 20:31:31 +0200

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,10 @@
  libopenal-dev,
  libasound2-dev,
  libguichan-dev,
- libtinyxml-dev
+ libtinyxml-dev,
+ libpng-dev,
+ libunittest++-dev,
+ glee-dev
 X-Python-Version: >= 2.6
 Vcs-Git: git://git.debian.org/git/pkg-games/fife.git
 Vcs-Browser: http://git.debian.org/?p=pkg-games/fife.git

## fife 0.3.4

=== debian/changelog ===
fife (0.3.4-3) unstable; urgency=low

  * Upload to unstable

 -- Christoph Egger <christoph@debian.org>  Sun, 23 Jun 2013 11:59:17 +0200

fife (0.3.4-2) experimental; urgency=low

  * Break older unknown-horizons as it only works with matching fife
    versions (Closes: #703214)

 -- Christoph Egger <christoph@debian.org>  Sun, 17 Mar 2013 17:53:43 +0100

fife (0.3.4-1) experimental; urgency=low

  * New upstream release

 -- Christoph Egger <christoph@debian.org>  Sat, 02 Mar 2013 16:06:30 -0800

=== debian/control ===
--- 
+++ 
@@ -29,14 +29,14 @@
 X-Python-Version: >= 2.6
 Vcs-Git: git://git.debian.org/git/pkg-games/fife.git
 Vcs-Browser: http://git.debian.org/?p=pkg-games/fife.git
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 Homepage: http://fifengine.de
 
 Package: python-fife
 Section: python
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
-Breaks: ${python:Breaks}
+Breaks: ${python:Breaks}, unknown-horizons (<< 2013.1)
 Description: FIFE is a multi-platform isometric game engine
  FIFE stands for Flexible Isometric Free Engine and is a cross
  platform game creation framework written in C++. It provides you with

## fife 0.3.5

=== SConstruct ===
--- 
+++ 
@@ -1,8 +1,8 @@
 # -*- coding: utf-8 -*-
 
 # ####################################################################
-#  Copyright (C) 2005-2009 by the FIFE team
-#  http://www.fifengine.de
+#  Copyright (C) 2005-2012 by the FIFE team
+#  http://www.fifengine.net
 #  This file is part of FIFE.
 #
 #  FIFE is free software; you can redistribute it and/or
@@ -42,7 +42,7 @@
 			ENV = os.environ,
 			DESTDIR = '${DESTDIR}')
 
-env.EnsureSConsVersion(1,2)
+env.EnsureSConsVersion(2,0)
 
 AddOption('--enable-debug',
 		dest='enable-debug',
@@ -305,6 +305,9 @@
 #set variables based on command line and environment options
 #**************************************************************************
 
+if os.environ.has_key('CXX'):
+	env['CXX'] = os.environ['CXX']
+
 if os.environ.has_key('SWIG'):
 	env['SWIG'] = os.environ['SWIG']
 
@@ -374,7 +377,7 @@
 		'PYLIB_COPY_DEST' : os.path.join('#engine', 'python', 'fife')}
 
 opts['FIFE_VERSION'] = utils.get_fife_version(os.path.join(opts['SRC'], 'core'));
-opts['FIFE_REVISION'] = utils.get_fife_revision()
+opts['FIFE_REVISION'] = utils.get_fife_revision(os.getcwd())
 
 if debug:
 	opts['LIBPATH'] = os.path.join(os.getcwd(), 'build', 'engine', 'debug')
@@ -396,4 +399,3 @@
 env.SConscript('ext/SConscript')
 
 #**************************************************************************
-#documentation target

=== build/linux/KDevelop/Makefile ===
FIFE:
	cd ../../.. && scons -Q tests=yes
clean:
	cd ../../.. && scons --clean

=== debian/changelog ===
fife (0.3.5-3) unstable; urgency=medium

  * Team upload.
  * Use compat level 9.
  * Vcs fields: Use https.
  * Declare compliance with Debian Policy 3.9.8.
  * wrap-and-sort -sa.
  * Add gcc6.diff and fix FTBFS with GCC-6.
    Thanks to Martin Michlmayr for the report and Graham Inggs for the patch.
    (Closes: #811858)
  * Add dh-python to Build-Depends.

 -- Markus Koschany <apo@debian.org>  Fri, 02 Sep 2016 22:45:56 +0200

fife (0.3.5-2) unstable; urgency=medium

  * Team upload.
  * Link gnukfreebsd10-config.py to gnukfreebsd9-config.py, this
    to fix builderror on kfreebsd. (Closes: #821765)
  * Add ext/guichan-0.8.2/config.(guess|sub) to d/clean

 -- Tobias Frost <tobi@debian.org>  Sat, 23 Apr 2016 21:46:57 +0200

fife (0.3.5-1) unstable; urgency=low

  * New upstream release

 -- Christoph Egger <christoph@debian.org>  Sun, 01 Sep 2013 16:48:59 +0200

=== debian/control ===
Source: fife
Uploaders:
 Christoph Egger <christoph@debian.org>
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Section: libdevel
Priority: optional
Build-Depends:
 chrpath,
 debhelper (>= 9),
 dh-python,
 glee-dev,
 libalut-dev,
 libasound2-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-regex-dev,
 libboost-test-dev,
 libguichan-dev,
 libopenal-dev,
 libpng-dev,
 libsdl-image1.2-dev,
 libsdl-ttf2.0-dev,
 libsdl1.2-dev,
 libtinyxml-dev,
 libunittest++-dev,
 libvorbis-dev,
 libxcursor-dev,
 python-all-dev (>= 2.6.6-3~),
 scons,
 swig,
 zlib1g-dev
X-Python-Version: >= 2.6
Vcs-Git: https://anonscm.debian.org/git/pkg-games/fife.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/fife.git
Standards-Version: 3.9.8
Homepage: http://fifengine.de

Package: python-fife
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Breaks:
 unknown-horizons (<< 2013.1),
 ${python:Breaks}
Description: FIFE is a multi-platform isometric game engine
 FIFE stands for Flexible Isometric Free Engine and is a cross
 platform game creation framework written in C++. It provides you with
 the ability to create a game using Python interfaces. FIFE also comes
 as a DLL or static library so you can use C++ as well.

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += -j$(NUMJOBS)
endif

%:
		dh $@ --with python2

override_dh_auto_configure:
	mkdir build-python$*
	ln -s gnukfreebsd9-config.py build/gnukfreebsd10-config.py
	cp -r build engine ext utils SConstruct setup.py test_fife.py build-python$*
	find build-python$*/engine/core/ext/tinyxml -type f -a \! -name fife_tinyxml.h -delete
	touch $@

override_dh_auto_build:
	python$* $(shell which scons) -C build-python$* fife-python $(SCONSOPTS)

override_dh_auto_test:
	python$* $(shell which scons) -C build-python$* tests $(SCONSOPTS)


override_dh_auto_install:
	python$* $(shell which scons) -C build-python$* DESTDIR=$(CURDIR)/debian/python-fife install-python $(SCONSOPTS)
	find $(CURDIR)/debian/python-fife -name '*.so' -exec chrpath -d {} \;

override_dh_auto_clean:
	rm -fr build-python*
	rm -f debian/stamps/*
	rm -f build/gnukfreebsd10-config.py
	dh_auto_clean

## fife 0.4.0

=== CMakeLists.txt ===
#------------------------------------------------------------------------------
#                                 Fifengine                                          
#------------------------------------------------------------------------------

cmake_minimum_required (VERSION 2.6)

project (fifengine)

#------------------------------------------------------------------------------
#                                 Version                                          
#------------------------------------------------------------------------------

set (FIFE_MAJOR_VERSION 0)
set (FIFE_MINOR_VERSION 4)
set (FIFE_PATCH_VERSION 0)

set(FIFE_VERSION ${FIFE_MAJOR_VERSION}.${FIFE_MINOR_VERSION}.${FIFE_PATCH_VERSION})

configure_file (
  "${PROJECT_SOURCE_DIR}/engine/core/version.h.in"
  "${PROJECT_SOURCE_DIR}/engine/core/version.h"
)

#------------------------------------------------------------------------------
#                                 Options                                          
#------------------------------------------------------------------------------

option(opengl           "Enable OpenGL support"                                 ON)
option(fifechan         "Enable Fifechan GUI subsystem"                         ON)
option(librocket        "Enable Librocket GUI subsystem"                        OFF)
option(cegui            "Enable Crazy Eddie's GUI subsystem"                    OFF)
option(zip              "Enable ZIP archive support"                            ON)
option(logging          "Enable logging"                                        ON)
option(rend-camzone     "Enable camera zone renderer"                           OFF)
option(rend-grid        "Enable camera grid renderer"                           OFF)
option(use-githash      "Try to determine the git hash for the current commit"  ON)
option(build-python     "Build the python extension module"                     ON)
option(build-library    "Build and install files to directly develop with c++"  OFF)

#------------------------------------------------------------------------------
#                                 Configure                                          
#------------------------------------------------------------------------------

# set path to our custom CMAKE scripts
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")

# Create a "Release" build by default.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Select build type. Options are: 'Debug', 'Release', 'RelWithDebInfo' and 'MinSizeRel'."
    FORCE
  )
  message(STATUS "Set CMAKE_BUILD_TYPE to default '${CMAKE_BUILD_TYPE}'.")
endif(NOT CMAKE_BUILD_TYPE)

# if building a C++ library is enabled, then build a shared library by default
# if you need a static library, set "-Dbuild-library=ON -DBUILD_SHARED_LIBS=OFF"
if(build-library)
  set(BUILD_SHARED_LIBS ON CACHE BOOL "Build a shared or static library")
endif(build-library)

# Do not allow an in-source-tree build, request an out-of-source-tree build.
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "#Please build outside of the source tree!\n                        
                       Make a separate folder for building and run CMake there:\n
                       mkdir _build; cd _build; cmake ..\n
                       Before that, cleanup:\nrm -rf CMakeCache.txt CMakeFiles")
endif()

# Disable in-source builds and modifications to the source tree.
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

# organize targets into folders
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

#------------------------------------------------------------------------------
#                                 Compiler Options                                         
#------------------------------------------------------------------------------

if(WIN32)

  if(MSVC)

    # ensure we use minimal "windows.h" lib without the crazy min max macros    
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"WIN32_LEAN_AND_MEAN\"")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"NOMINMAX\"")

    # disable SAFESEH - to avoid "LNK2026: module unsafe" on "OpenAL32.lib"
    SET(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} /D \"SAFESEH:NO\"")
    SET(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} /SAFESEH:NO")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /SAFESEH:NO")
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} /SAFESEH:NO")

    # use static libs - to avoid "LNK1104: cannot open file 'libboost_filesystem-vc140-mt-1_59.lib'"
    set(Boost_USE_STATIC_LIBS ON)     
    set(Boost_USE_MULTITHREADED ON)

  endif(MSVC)

endif(WIN32)

# defines

# define for using TinyXML with Standard Template Library (STL) support enabled
add_definitions(-DTIXML_USE_STL)

#------------------------------------------------------------------------------
#                                 Display Status                                         
#------------------------------------------------------------------------------

message("")
message("== Building FIFE version ${FIFE_VERSION} using build type '${CMAKE_BUILD_TYPE}'.")
message(STATUS "    Source directory is '${PROJECT_SOURCE_DIR}'.")
message(STATUS "    Build  directory is '${PROJECT_BINARY_DIR}'.")
message(STATUS "    Installation path is '${CMAKE_INSTALL_PREFIX}' (set -DCMAKE_INSTALL_PREFIX=<path> to change).")
message(STATUS "    CXX Compiler Flags: '${CMAKE_CXX_FLAGS}'.")
message(STATUS "    Dependencies folder: '${PROJECT_SOURCE_DIR}/../fifengine-dependencies'.")
message("")

#------------------------------------------------------------------------------
#                           Find Dependencies - Windows                                        
#------------------------------------------------------------------------------

# Tell CMake where to search for binaries (dlls), includes and libs on Windows
if(WIN32)
  set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH}

    # help to find dependencies on Appveyor

    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/build-tools/swig"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/bin"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/include"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/include/SDL2"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/include/OpenAL"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/includes/lib"

    # help to find dependencies on your local env (FifeSDK)

    "${PROJECT_SOURCE_DIR}/../swig"
    "${PROJECT_SOURCE_DIR}/../python"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/bin"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/boost"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/lib"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/lib/boost"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/SDL2"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/OpenAL"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/lib/x86"
    "${PROJECT_SOURCE_DIR}/../fifengine-dependencies/include/lib"
    
  )
endif(WIN32)

#------------------------------------------------------------------------------
#                                 Source Files                                         
#------------------------------------------------------------------------------

# tell compiler to search in the following folders for include files
include_directories("${PROJECT_BINARY_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/engine/core")
include_directories("${PROJECT_SOURCE_DIR}")

# Core
set (FIFE_CORE_SRC
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundclip.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundclipmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundemitter.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/audio/soundmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/controller/engine.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/controller/enginesettings.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/eventchannel/eventmanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/ext/glee/GLee.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/audio/ogg_loader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/audio/sounddecoder_ogg.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/animationloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/atlasloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/maploader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/objectloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/map/percentdonelistener.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/loaders/native/video/imageloader.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/model.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/action.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/object.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/timeprovider.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/cellgrid.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/hexgrid.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/metamodel/grids/squaregrid.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/cell.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/cellcache.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/instance.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/instancetree.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/layer.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/location.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/map.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/renderernode.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/trigger.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/model/structures/triggercontroller.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/route.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/routepather/multilayersearch.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/routepather/routepather.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/routepather/routepathersearch.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/pathfinder/routepather/singlelayersearch.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/savers/native/map/mapsaver.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/base/exception.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/base/fifeclass.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/base/stringutils.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/log/logger.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/math/angles.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/resource/resource.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/time/timeevent.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/time/timemanager.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/util/time/timer.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/directoryprovider.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/fife_boost_filesystem.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/vfs.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/vfsdirectory.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/vfssource.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/vfssourceprovider.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/dat/dat1.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/dat/dat2.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/dat/lzssdecoder.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/dat/rawdatadat1.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/dat/rawdatadat2.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/raw/rawdata.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/raw/rawdatafile.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/raw/rawdatamemsource.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/vfs/raw/rawdatasource.cpp
  ${PROJECT_SOURCE_DIR}/engine/core/video/animation.cpp

=== debian/changelog ===
fife (0.4.0-3) unstable; urgency=medium

  * Team upload.
  * debian/rules: Try to prevent build failures on mips and mipsel by using
    a single thread only and building with CMAKE_BUILD_TYPE=MinSizeRel.

 -- Markus Koschany <apo@debian.org>  Sun, 22 Jan 2017 01:16:48 +0100

fife (0.4.0-2) unstable; urgency=medium

  * Team upload.
  * Use dh_install --fail-missing to detect when files are not installed
    into the resulting binary package.
  * debian/rules: Pass --buildsystem=cmake to dh. (Closes: #851998)
  * Add clean file and ensure that fife can be built twice in a row.

 -- Markus Koschany <apo@debian.org>  Fri, 20 Jan 2017 20:11:52 +0100

fife (0.4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.4.0.
  * Tighten build-dependency on libfifechan-dev.
  * Drop all patches.
  * Switch from Scons to CMake.
  * Fix Lintian warning "extra license file".

 -- Markus Koschany <apo@debian.org>  Thu, 19 Jan 2017 23:58:16 +0100

fife (0.3.5+git160920-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.3.5+git160920.
  * Use compat level 10.
  * Add libfifechan-dev to Build-Depends.
  * Drop all patches. Fixed upstream.
  * Add debian/watch file. Thanks to Bart Martens.
  * Simplify debian/rules.
  * Switch from SDL1 to SDL2.
  * Delete static libraries to ensure that fife can be built twice in a row.
  * Remove debian/clean file.
  * Drop libguichan-dev from Build-Depends. It is obsolete now.
  * Add endif.patch and fix a FTBFS.

 -- Markus Koschany <apo@debian.org>  Mon, 07 Nov 2016 20:27:27 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Section: libdevel
 Priority: optional
 Build-Depends:
- chrpath,
- debhelper (>= 9),
+ cmake,
+ debhelper (>= 10),
  dh-python,
  glee-dev,
  libalut-dev,
@@ -15,24 +15,23 @@
  libboost-filesystem-dev,
  libboost-regex-dev,
  libboost-test-dev,
- libguichan-dev,
+ libfifechan-dev (>= 0.1.3),
  libopenal-dev,
  libpng-dev,
- libsdl-image1.2-dev,
- libsdl-ttf2.0-dev,
- libsdl1.2-dev,
+ libsdl2-image-dev,
+ libsdl2-ttf-dev,
+ libsdl2-dev,
  libtinyxml-dev,
  libunittest++-dev,
  libvorbis-dev,
  libxcursor-dev,
  python-all-dev (>= 2.6.6-3~),
- scons,
  swig,
  zlib1g-dev
 X-Python-Version: >= 2.6
+Standards-Version: 3.9.8
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/fife.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/fife.git
-Standards-Version: 3.9.8
 Homepage: http://fifengine.de
 
 Package: python-fife
